"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _reactRelay = require("react-relay");

var _reactRelay2 = require("../types/react-relay.d");

var _GlobalContext = _interopRequireDefault(require("../contexts/GlobalContext"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Query = function Query(props) {
  var query = props.query,
      variables = props.variables,
      children = props.children,
      dataFrom = props.dataFrom;

  var getVariables = function getVariables() {
    if (typeof variables === 'function') {
      return variables(props);
    }

    return variables;
  };

  var getDataFrom = function getDataFrom(config) {
    if (!dataFrom && config.ssrMode === true) {
      return _reactRelay2.DataFrom.STORE_THEN_NETWORK;
    }

    return dataFrom;
  };

  return React.createElement(_GlobalContext.default.Consumer, null, function (_ref) {
    var environment = _ref.environment,
        config = _ref.config;
    return React.createElement(_reactRelay.QueryRenderer, {
      environment: environment,
      query: query,
      variables: getVariables(),
      dataFrom: getDataFrom(config),
      render: function render(_ref2) {
        var queryProps = _ref2.props,
            error = _ref2.error,
            retry = _ref2.retry;
        return children(_objectSpread({}, queryProps, {
          error: error,
          retry: retry,
          isFetching: !queryProps && !error
        }));
      }
    });
  });
};

var _default = Query;
exports.default = _default;
//# sourceMappingURL=Query.js.map