"use strict";

var React = _interopRequireWildcard(require("react"));

var _enzyme = require("enzyme");

var _enzymeToJson = _interopRequireDefault(require("enzyme-to-json"));

var _components = require("../../../tests/components");

var _core = require("../../../tests/fixtures/core");

var _relay = require("../../../tests/fixtures/relay");

var _utils = require("../../../tests/utils");

var _ReleasyProvider = _interopRequireDefault(require("../ReleasyProvider"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

it('should render a loading Query', function () {
  global.fetch.mockResponseOnce(JSON.stringify((0, _relay.createQueryResponse)()), {
    status: 200,
    headers: {
      'content-type': 'application/json'
    }
  });
  var config = (0, _core.createConfig)();
  var component = (0, _enzyme.mount)(React.createElement(_ReleasyProvider.default, {
    config: config
  }, React.createElement(_components.MeQuery, null)));
  component.update();
  expect((0, _enzymeToJson.default)(component.find(_components.MeQuery).find('div'))).toMatchSnapshot();
});
it('should render a success Query',
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee() {
  var config, component;
  return regeneratorRuntime.wrap(function _callee$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          global.fetch.mockResponseOnce(JSON.stringify((0, _relay.createQueryResponse)()), {
            status: 200,
            headers: {
              'content-type': 'application/json'
            }
          });
          config = (0, _core.createConfig)();
          component = (0, _enzyme.mount)(React.createElement(_ReleasyProvider.default, {
            config: config
          }, React.createElement(_components.MeQuery, null)));
          _context.next = 5;
          return (0, _utils.delay)(100);

        case 5:
          component.update();
          expect((0, _enzymeToJson.default)(component.find(_components.MeQuery).find('div'))).toMatchSnapshot();

        case 7:
        case "end":
          return _context.stop();
      }
    }
  }, _callee, this);
})));
it('should use a function to create variables',
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee2() {
  var config, variables, component;
  return regeneratorRuntime.wrap(function _callee2$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          global.fetch.mockResponseOnce(JSON.stringify((0, _relay.createQueryResponse)()), {
            status: 200,
            headers: {
              'content-type': 'application/json'
            }
          });
          config = (0, _core.createConfig)();

          variables = function variables() {
            return {
              customVariable: 'customValue'
            };
          };

          component = (0, _enzyme.mount)(React.createElement(_ReleasyProvider.default, {
            config: config
          }, React.createElement(_components.MeQuery, {
            variables: variables
          })));
          _context2.next = 6;
          return (0, _utils.delay)(100);

        case 6:
          component.update();
          expect((0, _enzymeToJson.default)(component.find(_components.MeQuery).find('div'))).toMatchSnapshot();

        case 8:
        case "end":
          return _context2.stop();
      }
    }
  }, _callee2, this);
})));
//# sourceMappingURL=Query.spec.js.map