"use strict";

var React = _interopRequireWildcard(require("react"));

var _enzyme = require("enzyme");

var _core = require("../../../tests/fixtures/core");

var _GlobalContext = require("../../contexts/GlobalContext");

var _ReleasyProvider = _interopRequireDefault(require("../ReleasyProvider"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

it('should render a valid ReleasyProvider', function () {
  var config = (0, _core.createConfig)();
  var component = (0, _enzyme.shallow)(React.createElement(_ReleasyProvider.default, {
    config: config
  }, React.createElement("div", null)));
  expect(component.instance()).toMatchSnapshot();
});
it('should be capable to get Config statically', function () {
  var config = (0, _core.createConfig)();
  (0, _enzyme.shallow)(React.createElement(_ReleasyProvider.default, {
    config: config
  }, React.createElement("div", null)));
  expect((0, _GlobalContext.getConfig)()).toMatchSnapshot();
});
it('should be capable to get Environment statically', function () {
  var config = (0, _core.createConfig)();
  (0, _enzyme.shallow)(React.createElement(_ReleasyProvider.default, {
    config: config
  }, React.createElement("div", null)));
  expect((0, _GlobalContext.getEnvironment)()).toMatchSnapshot();
});
//# sourceMappingURL=ReleasyProvider.spec.js.map