"use strict";

var _InMemoryCache = _interopRequireDefault(require("../cache/InMemoryCache/InMemoryCache"));

var _Link = _interopRequireDefault(require("../link/Link/Link"));

var _Config = _interopRequireDefault(require("../Config"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

it('should create a valid Config', function () {
  var link = new _Link.default({
    url: '/graphql'
  });
  var config = new _Config.default({
    link: link
  });
  expect(config).toMatchSnapshot();
});
it('should create a Config with cache', function () {
  var link = new _Link.default({
    url: '/graphql'
  });
  var cache = new _InMemoryCache.default();
  var config = new _Config.default({
    link: link,
    cache: cache
  });
  expect(config).toMatchSnapshot();
});
it('should create a Config with ssrMode', function () {
  var link = new _Link.default({
    url: '/graphql'
  });
  var config = new _Config.default({
    link: link,
    ssrMode: true
  });
  expect(config).toMatchSnapshot();
});
//# sourceMappingURL=Config.spec.js.map