"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _RelayQueryResponseCache = _interopRequireDefault(require("relay-runtime/lib/RelayQueryResponseCache.js"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var InMemoryCache = function InMemoryCache(props) {
  var _this = this;

  _classCallCheck(this, InMemoryCache);

  _defineProperty(this, "store", void 0);

  _defineProperty(this, "get", function (queryID, variables) {
    return _this.store.get(queryID, variables);
  });

  _defineProperty(this, "set", function (queryID, variables, payload) {
    _this.store.set(queryID, variables, payload);
  });

  _defineProperty(this, "clear", function () {
    _this.store.clear();
  });

  _defineProperty(this, "size", function () {
    return _this.store._responses.size;
  });

  this.store = new _RelayQueryResponseCache.default({
    size: props && props.size ? props.size : 250,
    ttl: props && props.ttl ? props.ttl : 60 * 1000 * 5 // default = 5 minutes

  });
};

var _default = InMemoryCache;
exports.default = _default;
//# sourceMappingURL=InMemoryCache.js.map