"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _invariant = _interopRequireDefault(require("invariant"));

var _fetchWithRetries = _interopRequireDefault(require("fbjs/lib/fetchWithRetries"));

var _getHeaders = _interopRequireDefault(require("./getHeaders"));

var _getRequestBody = _interopRequireDefault(require("./getRequestBody"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Link = function Link(props) {
  var _this = this;

  _classCallCheck(this, Link);

  _defineProperty(this, "url", void 0);

  _defineProperty(this, "fetchTimeout", void 0);

  _defineProperty(this, "retryDelays", void 0);

  _defineProperty(this, "headers", void 0);

  _defineProperty(this, "fetch", function (request, variables, cacheConfig, uploadables) {
    return new Promise(
    /*#__PURE__*/
    function () {
      var _ref = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(resolve) {
        var customHeaders, headers, body, response, contentType;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                customHeaders = typeof _this.headers === 'function' ? _this.headers() : _this.headers;
                headers = _objectSpread({}, (0, _getHeaders.default)(uploadables), customHeaders);
                body = (0, _getRequestBody.default)(request, variables, uploadables);
                _context.next = 5;
                return (0, _fetchWithRetries.default)(_this.url, {
                  headers: headers,
                  body: body,
                  method: 'POST',
                  fetchTimeout: _this.fetchTimeout,
                  retryDelays: _this.retryDelays
                });

              case 5:
                response = _context.sent;
                contentType = response.headers.get('content-type');

                if (!(contentType && contentType.indexOf('application/json') !== -1)) {
                  _context.next = 10;
                  break;
                }

                resolve(response.json());
                return _context.abrupt("return");

              case 10:
                resolve(response.text());

              case 11:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }());
  });

  (0, _invariant.default)(props, 'Link: missing props');
  (0, _invariant.default)(props.url, 'Link: missing "url"');
  this.url = props.url;
  this.headers = props.headers || {};
  this.fetchTimeout = props.fetchTimeout || 30000;
  this.retryDelays = props.retryDelays || [1000, 3000, 5000, 10000];
};

var _default = Link;
exports.default = _default;
//# sourceMappingURL=Link.js.map