"use strict";

var _relay = require("../../../../../tests/fixtures/relay");

var _Link = _interopRequireDefault(require("../Link"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

it('should create a valid Link', function () {
  var link = new _Link.default({
    url: '/graphql'
  });
  expect(link).toMatchSnapshot();
});
it('should fetch default data',
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee() {
  var request, variables, cacheConfig, link, data;
  return regeneratorRuntime.wrap(function _callee$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          global.fetch.mockResponseOnce(JSON.stringify((0, _relay.createQueryResponse)()), {
            status: 200,
            headers: {
              'content-type': 'application/json'
            }
          });
          request = (0, _relay.createQueryRequest)();
          variables = (0, _relay.createVariables)();
          cacheConfig = (0, _relay.createCacheConfig)();
          link = new _Link.default({
            url: '/graphql'
          });
          _context.next = 7;
          return link.fetch(request, variables, cacheConfig);

        case 7:
          data = _context.sent;
          expect(data).toMatchSnapshot();

        case 9:
        case "end":
          return _context.stop();
      }
    }
  }, _callee, this);
})));
it('should fetch data with uploadables',
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee2() {
  var request, variables, cacheConfig, uploadables, link, data;
  return regeneratorRuntime.wrap(function _callee2$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          global.fetch.mockResponseOnce(JSON.stringify((0, _relay.createMutationResponse)()), {
            status: 200,
            headers: {
              'content-type': '*/*'
            }
          });
          request = (0, _relay.createMutationRequest)();
          variables = (0, _relay.createVariables)();
          cacheConfig = (0, _relay.createCacheConfig)();
          uploadables = (0, _relay.createUploadables)();
          link = new _Link.default({
            url: '/graphql'
          });
          _context2.next = 8;
          return link.fetch(request, variables, cacheConfig, uploadables);

        case 8:
          data = _context2.sent;
          expect(data).toMatchSnapshot();

        case 10:
        case "end":
          return _context2.stop();
      }
    }
  }, _callee2, this);
})));
it('should use custom headers',
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee3() {
  var request, variables, cacheConfig, link, data;
  return regeneratorRuntime.wrap(function _callee3$(_context3) {
    while (1) {
      switch (_context3.prev = _context3.next) {
        case 0:
          global.fetch.mockResponseOnce(JSON.stringify((0, _relay.createQueryResponse)()), {
            status: 200,
            headers: {
              'content-type': 'application/json'
            }
          });
          request = (0, _relay.createQueryRequest)();
          variables = (0, _relay.createVariables)();
          cacheConfig = (0, _relay.createCacheConfig)();
          link = new _Link.default({
            url: '/graphql',
            headers: function headers() {
              return {
                john: 'doe'
              };
            }
          });
          _context3.next = 7;
          return link.fetch(request, variables, cacheConfig);

        case 7:
          data = _context3.sent;
          expect(data).toMatchSnapshot();

        case 9:
        case "end":
          return _context3.stop();
      }
    }
  }, _callee3, this);
})));
//# sourceMappingURL=Link.spec.js.map