"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var getRequestBodyWithUploadables = function getRequestBodyWithUploadables(request, variables, uploadables) {
  var formData = new FormData();
  formData.append('query', request.text);
  formData.append('variables', JSON.stringify(variables));
  Object.keys(uploadables).forEach(function (key) {
    formData.append(key, uploadables[key]);
  });
  return formData;
};

var getRequestBodyWithoutUplodables = function getRequestBodyWithoutUplodables(request, variables) {
  return JSON.stringify({
    variables: variables,
    query: request.text
  });
};

var getRequestBody = function getRequestBody(request, variables, uploadables) {
  if (uploadables) {
    return getRequestBodyWithUploadables(request, variables, uploadables);
  }

  return getRequestBodyWithoutUplodables(request, variables);
};

var _default = getRequestBody;
exports.default = _default;
//# sourceMappingURL=getRequestBody.js.map