"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _constants = require("../../../utils/constants");

var _utils = require("../../../relay/utils");

var _Link = _interopRequireDefault(require("../Link/Link"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var VCRMode;

(function (VCRMode) {
  VCRMode["AUTO"] = "Auto";
  VCRMode["RECORD"] = "Record";
  VCRMode["REPLAY"] = "Replay";
})(VCRMode || (VCRMode = {}));

var VCR = function VCR(_ref) {
  var _this = this;

  var mode = _ref.mode,
      linkProps = _objectWithoutProperties(_ref, ["mode"]);

  _classCallCheck(this, VCR);

  _defineProperty(this, "link", void 0);

  _defineProperty(this, "mode", void 0);

  _defineProperty(this, "shelf", void 0);

  _defineProperty(this, "recordMode",
  /*#__PURE__*/
  function () {
    var _ref2 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee(request, variables, cacheConfig, uploadables) {
      var data, hash;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return _this.link.fetch(request, variables, cacheConfig, uploadables);

            case 2:
              data = _context.sent;
              hash = (0, _utils.getHash)(request, variables);
              _context.next = 6;
              return _this.shelf.set(hash, data);

            case 6:
              return _context.abrupt("return", data);

            case 7:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    return function (_x, _x2, _x3, _x4) {
      return _ref2.apply(this, arguments);
    };
  }());

  _defineProperty(this, "replayMode",
  /*#__PURE__*/
  function () {
    var _ref3 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee2(request, variables, cacheConfig, uploadables) {
      var hash;
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              hash = (0, _utils.getHash)(request, variables);
              return _context2.abrupt("return", _this.shelf.get(hash));

            case 2:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, this);
    }));

    return function (_x5, _x6, _x7, _x8) {
      return _ref3.apply(this, arguments);
    };
  }());

  _defineProperty(this, "autoMode",
  /*#__PURE__*/
  function () {
    var _ref4 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee3(request, variables, cacheConfig, uploadables) {
      var hash, exists;
      return regeneratorRuntime.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              hash = (0, _utils.getHash)(request, variables);
              _context3.next = 3;
              return _this.shelf.exists(hash);

            case 3:
              exists = _context3.sent;

              if (!exists) {
                _context3.next = 6;
                break;
              }

              return _context3.abrupt("return", _this.replayMode(request, variables, cacheConfig, uploadables));

            case 6:
              return _context3.abrupt("return", _this.recordMode(request, variables, cacheConfig, uploadables));

            case 7:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3, this);
    }));

    return function (_x9, _x10, _x11, _x12) {
      return _ref4.apply(this, arguments);
    };
  }());

  _defineProperty(this, "fetch",
  /*#__PURE__*/
  function () {
    var _ref5 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee4(request, variables, cacheConfig, uploadables) {
      return regeneratorRuntime.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              if (!(_this.mode === VCRMode.RECORD)) {
                _context4.next = 2;
                break;
              }

              return _context4.abrupt("return", _this.recordMode(request, variables, cacheConfig, uploadables));

            case 2:
              if (!(_this.mode === VCRMode.REPLAY)) {
                _context4.next = 4;
                break;
              }

              return _context4.abrupt("return", _this.replayMode(request, variables, cacheConfig, uploadables));

            case 4:
              return _context4.abrupt("return", _this.autoMode(request, variables, cacheConfig, uploadables));

            case 5:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4, this);
    }));

    return function (_x13, _x14, _x15, _x16) {
      return _ref5.apply(this, arguments);
    };
  }());

  this.link = new _Link.default(linkProps);
  this.mode = mode || VCRMode.AUTO;

  var importAndCreateShelf = function importAndCreateShelf() {
    if (_constants.IS_NODE) {
      var _VCRNodeShelf = require('./VCRNodeShelf').default;

      var _shelf = new _VCRNodeShelf();

      return _shelf;
    }

    var VCRNodeShelf = require('./VCRBrowserShelf').default;

    var shelf = new VCRNodeShelf();
    return shelf;
  };

  this.shelf = importAndCreateShelf();
};

_defineProperty(VCR, "MODE", VCRMode);

var _default = VCR;
exports.default = _default;
//# sourceMappingURL=VCR.js.map