"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.DIR = void 0;

var _fs = _interopRequireDefault(require("fs"));

var _path = _interopRequireDefault(require("path"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var DIR = _path.default.join(__dirname, '__vcr__');

exports.DIR = DIR;

var VCRNodeShelf = function VCRNodeShelf() {
  _classCallCheck(this, VCRNodeShelf);

  _defineProperty(this, "get", function (key) {
    return new Promise(function (resolve, reject) {
      var fullPath = _path.default.join(DIR, key);

      _fs.default.readFile(fullPath, 'utf8', function (error, data) {
        if (error) {
          return reject(error);
        }

        resolve(JSON.parse(data));
      });
    });
  });

  _defineProperty(this, "set", function (key, data) {
    return new Promise(function (resolve, reject) {
      var fullPath = _path.default.join(DIR, key);

      _fs.default.writeFile(fullPath, JSON.stringify(data), 'utf8', function (error) {
        if (error) {
          return reject(error);
        }

        resolve();
      });
    });
  });

  _defineProperty(this, "exists", function (key) {
    return new Promise(function (resolve, reject) {
      var fullPath = _path.default.join(DIR, key);

      resolve(_fs.default.existsSync(fullPath));
    });
  });

  if (!_fs.default.existsSync(DIR)) {
    _fs.default.mkdirSync(DIR);
  }
};

var _default = VCRNodeShelf;
exports.default = _default;
//# sourceMappingURL=VCRNodeShelf.js.map