"use strict";

var _fs = _interopRequireDefault(require("fs"));

var _relay = require("../../../../../tests/fixtures/relay");

var _utils = require("../../../../relay/utils");

var _VCRNodeShelf = require("../VCRNodeShelf");

var _VCR = _interopRequireDefault(require("../VCR"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

afterEach(function () {
  if (_fs.default.existsSync(_VCRNodeShelf.DIR)) {
    _fs.default.readdirSync(_VCRNodeShelf.DIR).forEach(function (file) {
      _fs.default.unlinkSync("".concat(_VCRNodeShelf.DIR, "/").concat(file));
    });

    _fs.default.rmdirSync(_VCRNodeShelf.DIR);
  }
});
it('should create a valid VCR', function () {
  var CONSTANTS = require('../../../../utils/constants');

  CONSTANTS.IS_NODE = true;
  var vcr = new _VCR.default({
    url: '/graphql'
  });
  expect(vcr).toMatchSnapshot();
});
it('should save data on record mode and retrieve data on replay mode',
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee() {
  var request, variables, cacheConfig, hash, vcrWithRecordMode, recordFetchData, recordCacheData, vcrWithReplayMode, replayFetchData;
  return regeneratorRuntime.wrap(function _callee$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          global.fetch.mockResponseOnce(JSON.stringify((0, _relay.createQueryResponse)()), {
            status: 200,
            headers: {
              'content-type': 'application/json'
            }
          });
          request = (0, _relay.createQueryRequest)();
          variables = (0, _relay.createVariables)();
          cacheConfig = (0, _relay.createCacheConfig)();
          hash = (0, _utils.getHash)(request, variables);
          vcrWithRecordMode = new _VCR.default({
            url: '/graphql',
            mode: _VCR.default.MODE.RECORD
          });
          expect(vcrWithRecordMode).toMatchSnapshot();
          _context.next = 9;
          return vcrWithRecordMode.fetch(request, variables, cacheConfig);

        case 9:
          recordFetchData = _context.sent;
          _context.next = 12;
          return vcrWithRecordMode.shelf.get(hash);

        case 12:
          recordCacheData = _context.sent;
          expect(recordFetchData).toEqual(recordCacheData);
          expect(recordCacheData).toMatchSnapshot();
          vcrWithReplayMode = new _VCR.default({
            url: '/graphql',
            mode: _VCR.default.MODE.REPLAY
          });
          expect(vcrWithReplayMode).toMatchSnapshot();
          _context.next = 19;
          return vcrWithReplayMode.fetch(request, variables, cacheConfig);

        case 19:
          replayFetchData = _context.sent;
          expect(recordFetchData).toEqual(replayFetchData);
          expect(replayFetchData).toMatchSnapshot();

        case 22:
        case "end":
          return _context.stop();
      }
    }
  }, _callee, this);
})));
it('should save and retrieve data on auto mode',
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee2() {
  var request, variables, cacheConfig, vcr, recordFetchData, replayFetchData;
  return regeneratorRuntime.wrap(function _callee2$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          global.fetch.mockResponseOnce(JSON.stringify((0, _relay.createQueryResponse)()), {
            status: 200,
            headers: {
              'content-type': 'application/json'
            }
          });
          request = (0, _relay.createQueryRequest)();
          variables = (0, _relay.createVariables)();
          cacheConfig = (0, _relay.createCacheConfig)();
          vcr = new _VCR.default({
            url: '/graphql'
          });
          _context2.next = 7;
          return vcr.fetch(request, variables, cacheConfig);

        case 7:
          recordFetchData = _context2.sent;
          _context2.next = 10;
          return vcr.fetch(request, variables, cacheConfig);

        case 10:
          replayFetchData = _context2.sent;
          expect(recordFetchData).toEqual(replayFetchData);
          expect(replayFetchData).toMatchSnapshot();

        case 13:
        case "end":
          return _context2.stop();
      }
    }
  }, _callee2, this);
})));
//# sourceMappingURL=VCR.node.spec.js.map