"use strict";

var _relay = require("../../../tests/fixtures/relay");

var _utils = require("../utils");

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

it('should verify if is a mutation',
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee() {
  var request;
  return regeneratorRuntime.wrap(function _callee$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          request = (0, _relay.createMutationRequest)();
          expect((0, _utils.isMutation)(request)).toMatchSnapshot();

        case 2:
        case "end":
          return _context.stop();
      }
    }
  }, _callee, this);
})));
it('should verify if is not a mutation',
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee2() {
  var request;
  return regeneratorRuntime.wrap(function _callee2$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          request = (0, _relay.createQueryRequest)();
          expect((0, _utils.isMutation)(request)).toMatchSnapshot();

        case 2:
        case "end":
          return _context2.stop();
      }
    }
  }, _callee2, this);
})));
it('should verify if must force a fetch',
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee3() {
  var cacheConfig;
  return regeneratorRuntime.wrap(function _callee3$(_context3) {
    while (1) {
      switch (_context3.prev = _context3.next) {
        case 0:
          cacheConfig = (0, _relay.createCacheConfig)({
            force: true
          });
          expect((0, _utils.mustForceFetch)(cacheConfig)).toMatchSnapshot();

        case 2:
        case "end":
          return _context3.stop();
      }
    }
  }, _callee3, this);
})));
it('should verify if must not force a fetch',
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee4() {
  var cacheConfig;
  return regeneratorRuntime.wrap(function _callee4$(_context4) {
    while (1) {
      switch (_context4.prev = _context4.next) {
        case 0:
          cacheConfig = (0, _relay.createCacheConfig)({
            force: false
          });
          expect((0, _utils.mustForceFetch)(cacheConfig)).toMatchSnapshot();

        case 2:
        case "end":
          return _context4.stop();
      }
    }
  }, _callee4, this);
})));
//# sourceMappingURL=utils.spec.js.map