"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _relayDevtools = require("relay-devtools");

var _relayRuntime = require("relay-runtime");

var _createNetwork = _interopRequireDefault(require("../network/createNetwork"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var createEnvironment = function createEnvironment(config) {
  if (config.devTools) {
    (0, _relayDevtools.installRelayDevTools)();
  }

  var network = (0, _createNetwork.default)(config);
  var recordSource = new _relayRuntime.RecordSource();
  var store = new _relayRuntime.Store(recordSource);
  return new _relayRuntime.Environment({
    network: network,
    store: store
  });
};

var _default = createEnvironment;
exports.default = _default;
//# sourceMappingURL=createEnvironment.js.map