"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _RelayNetworkLogger = _interopRequireDefault(require("relay-runtime/lib/RelayNetworkLogger"));

var _utils = require("../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var FetchResolver =
/*#__PURE__*/
function () {
  function FetchResolver(config) {
    _classCallCheck(this, FetchResolver);

    _defineProperty(this, "config", void 0);

    this.config = config;
  }

  _createClass(FetchResolver, [{
    key: "resolve",
    value: function () {
      var _resolve = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(request, variables, cacheConfig, uploadables, sink) {
        var fetchFn, data;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                fetchFn = this.config.networkLogger ? _RelayNetworkLogger.default.wrapFetch(this.config.link.fetch) : this.config.link.fetch;
                _context.prev = 1;

                if ((0, _utils.isMutation)(request) && !!this.config.cache) {
                  this.config.cache.clear();
                }

                _context.next = 5;
                return fetchFn(request, variables, cacheConfig, uploadables);

              case 5:
                data = _context.sent;

                if (!(0, _utils.isMutation)(request) && !!this.config.cache) {
                  this.config.cache.set(request.text, variables, data);
                }

                sink.next(data);
                sink.complete();
                _context.next = 15;
                break;

              case 11:
                _context.prev = 11;
                _context.t0 = _context["catch"](1);
                sink.error(_context.t0);
                sink.complete();

              case 15:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this, [[1, 11]]);
      }));

      return function resolve(_x, _x2, _x3, _x4, _x5) {
        return _resolve.apply(this, arguments);
      };
    }()
  }]);

  return FetchResolver;
}();

var _default = FetchResolver;
exports.default = _default;
//# sourceMappingURL=FetchResolver.js.map