"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getHash = exports.mustForceFetch = exports.isMutation = void 0;

var _stableCopy = _interopRequireDefault(require("relay-runtime/lib/stableCopy.js"));

var _stringHash = _interopRequireDefault(require("string-hash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var isMutation = function isMutation(request) {
  return request.operationKind === 'mutation';
};

exports.isMutation = isMutation;

var mustForceFetch = function mustForceFetch(cacheConfig) {
  return !!(cacheConfig && cacheConfig.force);
};

exports.mustForceFetch = mustForceFetch;

var getHash = function getHash(request, variables) {
  var copy = (0, _stableCopy.default)({
    variables: variables || {},
    query: request.text
  });
  var name = request.name;
  var hash = (0, _stringHash.default)(JSON.stringify(copy)).toString();
  return "".concat(name, "_").concat(hash);
};

exports.getHash = getHash;
//# sourceMappingURL=utils.js.map