"use strict";

var React = _interopRequireWildcard(require("react"));

var ReactDOM = _interopRequireWildcard(require("react-dom"));

var _components = require("../../../tests/components");

var _core = require("../../../tests/fixtures/core");

var _relay = require("../../../tests/fixtures/relay");

var _constants = require("../../utils/constants");

var _ReleasyProvider = _interopRequireDefault(require("../../components/ReleasyProvider"));

var _renderToStringWithData = _interopRequireDefault(require("../renderToStringWithData"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

it('should render to string with data',
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee() {
  var config, result;
  return regeneratorRuntime.wrap(function _callee$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          global.fetch.mockResponse(JSON.stringify((0, _relay.createQueryResponse)()), {
            status: 200,
            headers: {
              'content-type': 'application/json'
            }
          });
          config = (0, _core.createConfig)({
            ssrMode: true
          });
          _context.next = 4;
          return (0, _renderToStringWithData.default)(React.createElement(_ReleasyProvider.default, {
            config: config
          }, React.createElement(_components.MeQuery, null)));

        case 4:
          result = _context.sent;
          expect(result).toMatchSnapshot();

        case 6:
        case "end":
          return _context.stop();
      }
    }
  }, _callee, this);
})));
it('should hydrate with data',
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee2() {
  var rootElement, serverConfig, _ref3, html, scripts, data, clientConfig;

  return regeneratorRuntime.wrap(function _callee2$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          global.fetch.mockResponse(JSON.stringify((0, _relay.createQueryResponse)()), {
            status: 200,
            headers: {
              'content-type': 'application/json'
            }
          });
          rootElement = document.createElement('div');
          serverConfig = (0, _core.createConfig)({
            ssrMode: true
          });
          _context2.next = 5;
          return (0, _renderToStringWithData.default)(React.createElement(_ReleasyProvider.default, {
            config: serverConfig
          }, React.createElement(_components.MeQuery, null)));

        case 5:
          _ref3 = _context2.sent;
          html = _ref3.html;
          scripts = _ref3.scripts;
          data = scripts.match(new RegExp('<script[^>]*>(.*?)</script[^>]*>'))[1].split(' = ').pop();
          window[_constants.WINDOW_DATA_KEY] = JSON.parse(data);
          rootElement.innerHTML = html;
          clientConfig = (0, _core.createConfig)();
          ReactDOM.hydrate(React.createElement(_ReleasyProvider.default, {
            config: clientConfig
          }, React.createElement(_components.MeQuery, null)), rootElement, function () {
            expect(rootElement.innerHTML).toMatchSnapshot();
          });

        case 13:
        case "end":
          return _context2.stop();
      }
    }
  }, _callee2, this);
})));
//# sourceMappingURL=renderToStringWithData.spec.js.map