"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var ReactDOM = _interopRequireWildcard(require("react-dom/server"));

var _constants = require("../utils/constants");

var _utils = require("../relay/utils");

var _getDataFromTree = _interopRequireDefault(require("./getDataFromTree"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var renderToStringWithData =
/*#__PURE__*/
function () {
  var _ref = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee(component) {
    var dataFromTree, byHash, html, scripts;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return (0, _getDataFromTree.default)(component);

          case 2:
            dataFromTree = _context.sent;
            byHash = dataFromTree.reduce(function (accumulator, _ref2) {
              var request = _ref2.request,
                  variables = _ref2.variables,
                  data = _ref2.data;
              var hash = (0, _utils.getHash)(request, variables);
              return _objectSpread({}, accumulator, _defineProperty({}, hash, data));
            }, {});
            html = ReactDOM.renderToString(component);
            scripts = "<script>window.".concat(_constants.WINDOW_DATA_KEY, " = ").concat(JSON.stringify(byHash), "</script>");
            return _context.abrupt("return", {
              html: html,
              scripts: scripts
            });

          case 7:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function renderToStringWithData(_x) {
    return _ref.apply(this, arguments);
  };
}();

var _default = renderToStringWithData;
exports.default = _default;
//# sourceMappingURL=renderToStringWithData.js.map