"use strict";

var _fetchSchema = _interopRequireDefault(require("../fetchSchema"));

var _fs = _interopRequireDefault(require("fs"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

it('should fetch the schema',
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee() {
  var CONSTANTS, json, result, pathExists;
  return regeneratorRuntime.wrap(function _callee$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          CONSTANTS = require('../../utils/constants');
          CONSTANTS.IS_NODE = true;
          json = require('../../../tests/data/schema.json');
          global.fetch.mockResponseOnce(JSON.stringify(json), {
            status: 200,
            headers: {
              'content-type': 'application/json'
            }
          });
          _context.next = 6;
          return (0, _fetchSchema.default)({
            url: '/graphql',
            dir: './tests/data'
          });

        case 6:
          result = _context.sent;
          pathExists = _fs.default.existsSync(result.path);
          expect(pathExists).toBe(true);
          expect(result).toMatchSnapshot();

        case 10:
        case "end":
          return _context.stop();
      }
    }
  }, _callee, this);
})));
it('should create the dir if it doesnt exist',
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee2() {
  var json, dir, result, dirExists;
  return regeneratorRuntime.wrap(function _callee2$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          json = require('../../../tests/data/schema.json');
          global.fetch.mockResponseOnce(JSON.stringify(json), {
            status: 200,
            headers: {
              'content-type': 'application/json'
            }
          });
          dir = './tests/non-existing';
          _context2.next = 5;
          return (0, _fetchSchema.default)({
            dir: dir,
            url: '/graphql'
          });

        case 5:
          result = _context2.sent;
          dirExists = _fs.default.existsSync(dir);
          expect(dirExists).toBe(true);

          _fs.default.unlinkSync(result.path);

          _fs.default.rmdirSync(dir);

        case 10:
        case "end":
          return _context2.stop();
      }
    }
  }, _callee2, this);
})));
it('should thrown an error on a non node environment', function () {
  var CONSTANTS = require('../../utils/constants');

  CONSTANTS.IS_NODE = false;

  var callFetchSchema = function callFetchSchema() {
    return (0, _fetchSchema.default)({
      url: '/graphql',
      dir: './tests/data'
    });
  };

  expect(callFetchSchema()).rejects.toThrowErrorMatchingSnapshot();
});
//# sourceMappingURL=fetchSchema.spec.js.map