"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _graphql = require("graphql");

var _constants = require("../utils/constants");

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var fetchSchema =
/*#__PURE__*/
function () {
  var _ref = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee(input) {
    var fs, fetchWithRetries, url, dir, _input$filename, filename, response, result, clientSchema, schema, path;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (_constants.IS_NODE) {
              _context.next = 2;
              break;
            }

            throw new Error('Node.JS environments only!');

          case 2:
            fs = require('fs');
            fetchWithRetries = require('fbjs/lib/fetchWithRetries');
            url = input.url, dir = input.dir, _input$filename = input.filename, filename = _input$filename === void 0 ? 'schema.graphql' : _input$filename;
            _context.next = 7;
            return fetchWithRetries(url, {
              method: 'POST',
              headers: {
                Accept: 'application/json',
                'Content-Type': 'application/json'
              },
              body: JSON.stringify({
                query: _graphql.introspectionQuery
              })
            });

          case 7:
            response = _context.sent;
            _context.next = 10;
            return response.json();

          case 10:
            result = _context.sent;
            clientSchema = (0, _graphql.buildClientSchema)(result.data);
            schema = (0, _graphql.printSchema)(clientSchema);

            if (!fs.existsSync(dir)) {
              fs.mkdirSync(dir);
            }

            path = "".concat(dir, "/").concat(filename);
            fs.writeFileSync(path, schema);
            return _context.abrupt("return", {
              path: path
            });

          case 17:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function fetchSchema(_x) {
    return _ref.apply(this, arguments);
  };
}();

var _default = fetchSchema;
exports.default = _default;
//# sourceMappingURL=fetchSchema.js.map